LinuxQuestions.org

LinuxQuestions.org (/questions/)
-   Slackware (https://www.linuxquestions.org/questions/slackware-14/)
-   -   Slackware from Scratch and X11 (https://www.linuxquestions.org/questions/slackware-14/slackware-from-scratch-and-x11-4175560702/)

marav 08-16-2022 09:37 AM

Quote:

Originally Posted by nobodino (Post 6374049)
I haven't the git repo for dhcpcd?

https://github.com/NetworkConfiguration/dhcpcd
and
https://roy.marples.name/git/dhcpcd

EDIT: Roy is on holiday, so we'll wait a bit, at least for a reply

marav 08-16-2022 01:48 PM

From Roy:
Code:

Looks like we need to add a define for __NR_getrandom in privsep-linux.c

I can prepare a patch when I get back from holiday next week unless
someone else can beat me to it.


nobodino 08-18-2022 02:54 AM

The problem with the kdepim mailcommon package and cmake is solved with the new version of cmake-3.24.1

marav 08-26-2022 03:20 AM

Quote:

Originally Posted by nobodino (Post 6373987)
However, there's a problem with dhcpcd built with glibc-2.36:

Thanks to Roy for his reactivity
Code:

[PATCH] privsep: Allow getrandom sysctl for newer glibc
https://github.com/NetworkConfigurat...704d5f52.patch

EDIT: just tested and, of course, it works

+
Code:

privsep: Allow newfstatat syscall as well
Allows newer glibc variants to work apparently.

https://github.com/NetworkConfigurat...d74c4ff5.patch

nobodino 08-26-2022 09:50 AM

ok, included in the SFS build tree.

nobodino 08-27-2022 01:34 AM

apparently there's another patch concerning glibc-2.36 : https://github.com/NetworkConfigurat...733585d74c4ff5

with this patch : https://github.com/NetworkConfigurat...d74c4ff5.patch

updated SFS source build tree.

created a git version of dhcpcd which works: https://github.com/nobodino/slackwar...cd-git-version

marav 08-27-2022 03:04 AM

Quote:

Originally Posted by nobodino (Post 6376466)
apparently there's another patch concerning glibc-2.36 : https://github.com/NetworkConfigurat...733585d74c4ff5

with this patch : https://github.com/NetworkConfigurat...d74c4ff5.patch

updated SFS source build tree.

created a git version of dhcpcd which works: https://github.com/nobodino/slackwar...cd-git-version

You need to re-read my post ;-)

nobodino 08-27-2022 05:32 AM

you're right.
Thanks.

nobodino 10-16-2022 02:26 AM

Regression test up to "Fri Oct 14 01:39:37 UTC 2022" (x86_64 version).

Just 2 remaining packages don't build correctly:
- f2fs need a patch to build with lz4-1.9.4 (see: https://www.linuxquestions.org/quest...ls-4175715792/)
Code:

diff -aurN f2fs-tools-1.15.0/fsck/compress.c f2fs-tools-1.15.0-mod/fsck/compress.c
--- f2fs-tools-1.15.0/fsck/compress.c        2022-05-13 19:50:41.000000000 +0200
+++ f2fs-tools-1.15.0-mod/fsck/compress.c        2022-08-19 12:15:48.037589094 +0200
@@ -32,10 +32,10 @@
 #ifdef HAVE_LIBLZ4
 #define LZ4_MEMORY_USAGE                14
 #define LZ4_MAX_INPUT_SIZE                0x7E000000 /* 2 113 929 216 bytes */
-#ifndef LZ4_STREAMSIZE
-#define LZ4_STREAMSIZE                        (LZ4_STREAMSIZE_U64 * sizeof(long long))
+#ifndef LZ4_STREAM_MINSIZE
+#define LZ4_STREAM_MINSIZE  ((1UL << LZ4_MEMORY_USAGE) + 32)  /* static size, for inter-version compatibility */
 #endif
-#define LZ4_MEM_COMPRESS                LZ4_STREAMSIZE
+#define LZ4_MEM_COMPRESS              LZ4_STREAM_MINSIZE
 #define LZ4_ACCELERATION_DEFAULT        1
 #define LZ4_WORK_SIZE                        ALIGN_UP(LZ4_MEM_COMPRESS, 8)
 #endif

- pangomm refuse to build because of pango changes in headers files (see : https://www.linuxquestions.org/quest...mm-4175716509/)

here' what's left:

Code:

--- list-slackware        2022-10-16 09:17:41.244788733 +0200
+++ list-sfs        2022-10-16 09:17:41.256788878 +0200
@@ -29,7 +29,7 @@
 a/etc-15.1-x86_64-2.txz
 a/eudev-3.2.11-x86_64-2.txz
 a/exfatprogs-1.1.3-x86_64-1.txz
-a/f2fs-tools-1.15.0-x86_64-1.txz
+a/f2fs-tools-1.15.0-x86_64-1_sfs.txz
 a/file-5.43-x86_64-1.txz
 a/findutils-4.9.0-x86_64-1.txz
 a/floppy-5.5-x86_64-4.txz
@@ -927,7 +927,7 @@
 l/opusfile-0.12-x86_64-3.txz
 l/orc-0.4.32-x86_64-3.txz
 l/pango-1.50.11-x86_64-1.txz
-l/pangomm-2.42.2-x86_64-3.txz
+l/pangomm-2.46.2-x86_64-3.txz
 l/parted-3.5-x86_64-1.txz
 l/pcaudiolib-1.2-x86_64-1.txz
 l/pcre2-10.40-x86_64-2.txz


nobodino 10-29-2022 07:44 AM

Regression test up to "Thu Oct 27 02:30:15 UTC 2022" (x86_64 version).

Not too bad, only one remaining package refusing to build.

Code:

--- list-slackware        2022-10-29 14:42:21.062632918 +0200
+++ list-sfs        2022-10-29 14:42:21.076633083 +0200
@@ -927,7 +927,7 @@
 l/opusfile-0.12-x86_64-3.txz
 l/orc-0.4.32-x86_64-3.txz
 l/pango-1.50.11-x86_64-1.txz
-l/pangomm-2.42.2-x86_64-3.txz
+l/pangomm-2.46.2-x86_64-3.txz
 l/parted-3.5-x86_64-1.txz
 l/pcaudiolib-1.2-x86_64-1.txz
 l/pcre2-10.40-x86_64-2.txz


nobodino 11-03-2022 02:42 AM

Regression test up to "Mon Oct 31 23:31:36 UTC 2022" (x86_64 version).

Except glibc and s-nail packages which had problems with new make package, nothing new under the sun.

lucabon 12-12-2022 10:06 AM

Nethack no more build from gcc 12 (not detected because the package was build also with errors).

Fixing config.h:

--- nethack.SlackBuild.orig 2022-09-15 20:23:58.052165083 +0200
+++ nethack.SlackBuild 2022-12-12 17:04:44.146540910 +0100
@@ -107,6 +107,9 @@

sed -e "/^MANDIR\s*=/s|/usr/man/man6|$PKG/usr/man/man6|" -i sys/unix/Makefile.doc

+# Fixing gcc 12 compatibility:
+sed -i 's/#define UNIX/#include <stdlib.h>\n#include <stdio.h>\n&/' include/config.h
+

# Create a few directories:
mkdir -p $PKG/usr/man/man6
mkdir -p $PKG/usr/doc/nethack-$VERSION
@@ -116,7 +119,7 @@
( cd sys/unix ; sh setup.sh hints/linux )

# Build and install:
-make -j1 install manpages PREFIX=$PKG
+make -j1 install manpages PREFIX=$PKG || exit 1

# Fix some paths:
sed -e "s|HACKDIR=$PKG/|HACKDIR=/|" \

marav 12-12-2022 06:58 PM

Quote:

Originally Posted by lucabon (Post 6397444)
Nethack no more build from gcc 12 (not detected because the package was build also with errors).

Fixing config.h:

--- nethack.SlackBuild.orig 2022-09-15 20:23:58.052165083 +0200
+++ nethack.SlackBuild 2022-12-12 17:04:44.146540910 +0100
@@ -107,6 +107,9 @@

sed -e "/^MANDIR\s*=/s|/usr/man/man6|$PKG/usr/man/man6|" -i sys/unix/Makefile.doc

+# Fixing gcc 12 compatibility:
+sed -i 's/#define UNIX/#include <stdlib.h>\n#include <stdio.h>\n&/' include/config.h
+

# Create a few directories:
mkdir -p $PKG/usr/man/man6
mkdir -p $PKG/usr/doc/nethack-$VERSION
@@ -116,7 +119,7 @@
( cd sys/unix ; sh setup.sh hints/linux )

# Build and install:
-make -j1 install manpages PREFIX=$PKG
+make -j1 install manpages PREFIX=$PKG || exit 1

# Fix some paths:
sed -e "s|HACKDIR=$PKG/|HACKDIR=/|" \

They made a patch, long time ago ... (Jan. 4)
https://github.com/NetHack/NetHack/c...7442ed7ff2fe4e

xlfs-0.2 12-14-2022 07:07 PM

I do think libepoxy should be done, and it shouldn' be difficult.

gelf.h is not required for <=Xorg-22 nor <=mesa-22, it must be an option of something optional (GL and firefox work without it, as for the rest IDK)

> 6) Also had to recompile glib2 before gtk-pixbuf2 would compile.

perhaps that is because you inadvertently changed the order?

or maybe slack-build is not an "error free build" ?

========================
if you recompile Xorg after the build (or rather proceed forward then recompile it)

YOU WILL need to recompile xf86-input-* xf86-video-*, since they are coded to not load unless built after Xorg

nobodino 12-15-2022 01:22 AM

@xlfs-0.2: I don't understand a single word of what you're talking about, sorry.

I looked at your profile, you're trying to build XLFS, that's fine.
I'll look at your project during christmas holydays, but clearly I don't understand your message!

nobodino 12-30-2022 02:45 PM

Regression test up to "Sun Dec 25 23:21:25 UTC 2022" (x86_64 version).

Nothing special, except the qt5-webkit package (problem solved in another thread) and always the same pangomm.

marav 01-04-2023 02:50 PM

@nobodino

When do you recompile the entire stack ?
Do you plan it, or after every updates ?

nobodino 01-05-2023 12:19 PM

For now, Slackware has become very solid according to the possibility to be rebuilt from scratch, it doesn't need to be recompiled with every bit of software changed.

I only do it on the week-end and if I have enough time to do it.

Now I recompile it every time:
- one of the glibc / binutils or gcc change: a special attention to glibc with deprecated features (twice a year for glibc and binutils)
- one of the automake / autoconf / make /texinfo change: those gnu packages are not always safe as upgrade.
- rust change because of its impact on firefox / thunderbird and seamonkey.
- python3 change, if python3-3.10.x comes back or python3-3.11.x
- if while building the "tools" something odd occures, I'm sure I've to recompile the all set.

Otherwise, if I waited a too long time, around a month, I give it a try.

nobodino 01-17-2023 12:27 PM

Regression test up to "Sun Jan 15 01:02:36 UTC 2023" (x86_64 version) with binutils-2.40.

Except:
- qt5-webkit package (problem solved in another thread)
- always the same pangomm
- gdb (problem solved in another thread)

Nothing else.

nobodino 02-05-2023 12:43 AM

Regression test up to "Fri Feb 3 20:04:33 UTC 2023" (x86_64 version).

Except:
- qt5-webkit (same problem)
- pangomm (same problem)

lucabon 02-12-2023 07:59 PM

With .so version bump for the latest libvpx upgrade (1.12: libvpx.so.7 => 1.13: libvpx.so.8), some packages should be rebuilt:
- ffmpeg
- gst-plugins-good
- qt5
- xine-lib

Thanks!

marav 02-12-2023 07:59 PM

Quote:

Originally Posted by lucabon (Post 6410889)
With .so version bump for the latest libvpx upgrade (1.12: libvpx.so.7 => 1.13: libvpx.so.8), some packages should be rebuilt:
- ffmpeg
- gst-plugins-good
- qt5
- xine-lib

Thanks!

Too late ;-)
https://www.linuxquestions.org/quest...nt-4175698890/

lucabon 02-12-2023 09:07 PM

Quote:

Originally Posted by marav (Post 6410890)

Sorry... I didn't refresh the changelog :-S

lucabon 02-14-2023 04:24 AM

If vulkan-sdk is compiled after qt5 (as needed if you want to have qt5-based tools), compiling VulkanTools will fail if gcc>=12 due to uninitialized variables.

Simple "patch" to solve the problem:

--- a/source/x/vulkan-sdk/vulkan-sdk.SlackBuild
+++ b/source/x/vulkan-sdk/vulkan-sdk.SlackBuild
@@ -383,6 +388,9 @@
tar xvf $CWD/VulkanTools-sdk-$VULKANTOOLS_VERSION.tar.?z || exit 1
cd $TMP/VulkanTools-sdk-$VULKANTOOLS_VERSION

+# Fix warning-error on gcc 12 about uninitialized variables:
+sed -i 's/Value v;/Value v(0);/' submodules/jsoncpp/src/lib_json/json_reader.cpp
+
chown -R root:root .
find . \
\( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \

lucabon 02-27-2023 02:45 AM

1 Attachment(s)
From sqlite 3.41, double-quotes are not more accepted by default as string literal.

Package ibus-libpinyin uses double-quotes for string literal, so if compile after sqlite3 (as in Slackware from Scratch) it will fail to build english.db.

Already fixed in github repository: https://github.com/libpinyin/ibus-li...88942af438ea98

lucabon 03-01-2023 01:42 PM

cups-filters does not compile against newer qpdf that uses std::string_view (available only from c++17).

There are 2 possible solutions:
1) Replace in the build script:
Code:

CXXFLAGS="$SLKCFLAGS -std=c++11 -fpermissive"
with
Code:

CXXFLAGS="$SLKCFLAGS -std=c++17 -fpermissive"
2) Remove "-std=c++11" from build script and patch Makefile.am:

Code:

--- cups-filters-1.28.17/Makefile.am.orig
+++ cups-filters-1.28.17/Makefile.am

@@ -528,7 +528,7 @@
 pdftopdf_CFLAGS = \
        $(LIBQPDF_CFLAGS) \
        $(CUPS_CFLAGS)
-pdftopdf_CXXFLAGS = -std=c++0x $(pdftopdf_CFLAGS)  # -std=c++11
+pdftopdf_CXXFLAGS = -std=c++17 $(pdftopdf_CFLAGS)
 pdftopdf_LDADD = \
        $(LIBQPDF_LIBS) \
        $(CUPS_LIBS)


marav 03-02-2023 05:09 AM

Quote:

Originally Posted by lucabon (Post 6414679)
cups-filters does not compile against newer qpdf that uses std::string_view (available only from c++17).

There are 2 possible solutions:
1) Replace in the build script:
Code:

CXXFLAGS="$SLKCFLAGS -std=c++11 -fpermissive"
with
Code:

CXXFLAGS="$SLKCFLAGS -std=c++17 -fpermissive"
2) Remove "-std=c++11" from build script and patch Makefile.am:

Code:

--- cups-filters-1.28.17/Makefile.am.orig
+++ cups-filters-1.28.17/Makefile.am

@@ -528,7 +528,7 @@
 pdftopdf_CFLAGS = \
        $(LIBQPDF_CFLAGS) \
        $(CUPS_CFLAGS)
-pdftopdf_CXXFLAGS = -std=c++0x $(pdftopdf_CFLAGS)  # -std=c++11
+pdftopdf_CXXFLAGS = -std=c++17 $(pdftopdf_CFLAGS)
 pdftopdf_LDADD = \
        $(LIBQPDF_LIBS) \
        $(CUPS_LIBS)


Fixed:

Code:

ap/FTBFSlog
Wed Mar  1 20:05:44 UTC 2023
  cups-filters: change to -std=c++17. Thanks to lucabon.


nobodino 03-19-2023 05:20 AM

Regression test up to "Fri Mar 17 20:12:03 UTC 2023" (x86_64 version), which is on "Happy Saint Paddy's Day!"

Very few regression, and one is already closed:
- the green one
- the blue one has 2 solutions, one from me, another from marav.

Code:

--- list-slackware        2023-03-19 11:15:38.008100233 +0100
+++ list-sfs        2023-03-19 11:15:38.036100536 +0100
@@ -955,7 +955,6 @@
 l/pygtk-2.24.0-x86_64-7.txz
 l/pyparsing-2.4.7-x86_64-6.txz
 l/PyQt5-5.15.2-x86_64-5.txz
-l/python2-module-collection-2.7.18-x86_64-6.txz
 l/python-alabaster-0.7.12-x86_64-1.txz
 l/python-appdirs-1.4.4-x86_64-6.txz
 l/python-babel-2.10.1-x86_64-1.txz
@@ -1311,7 +1310,6 @@
 x/fcitx5-chinese-addons-5.0.17-x86_64-1.txz
 x/fcitx5-gtk-5.0.22-x86_64-1.txz
 x/fcitx5-hangul-5.0.11-x86_64-1.txz
-x/fcitx5-kkc-5.0.12-x86_64-1.txz
 x/fcitx5-m17n-5.0.11-x86_64-1.txz
 x/fcitx5-qt-5.0.17-x86_64-1.txz
 x/fcitx5-sayura-5.0.8-x86_64-1.txz

Quite ready for a beta release.

lucabon 04-13-2023 06:34 AM

Regression building mesa after upgrading rust-bindgen to 0.65.

Solution in thread https://www.linuxquestions.org/quest...-a-4175724025/

nobodino 05-01-2023 02:57 AM

Regression test up to "Fri Apr 28 18:25:13 UTC 2023" (x86_64 version) with gcc-13.1.

Not so bad but, here are some non building packgages:
- nodejs: problem solved by marav
- ncftp: problem solved by marav
- mariadb: problem solved by marav
- vulkan-sdk: no complete solution
- qt5webkit: problem solved
- qt-5.19.6: problem solved by marav
- mozilla-thunderbird: problem solved by marav
- python2-module-scollection: need to upgrade M2crypto package to 0.38.0

Specific to SFS:
- llvm: doesn't build on SFS with gcc-13.1 for the 1st pass

marav 05-02-2023 06:25 AM

Quote:

Originally Posted by nobodino (Post 6428130)
Regression test up to "Fri Apr 28 18:25:13 UTC 2023" (x86_64 version) with gcc-13.1.

Not so bad but, here are some non building packgages:
- nodejs: problem solved by marav
- ncftp: problem solved by marav
- mariadb: problem solved by marav
- vulkan-sdk: no complete solution
- qt5webkit: problem solved
- qt-5.19.6: problem solved by marav
- mozilla-thunderbird: problem solved by marav
- python2-module-scollection: need to upgrade M2crypto package to 0.38.0

Specific to SFS:
- llvm: doesn't build on SFS with gcc-13.1 for the 1st pass

We still have vulkan-sdk
Honestly, I don't know. Mostly others don't seem to compile DirectXShaderCompiler or Vulkan-Profiles
and gcc 13 has only just arrived in the testing/ branch of Arch
So, wait and see

lucabon 05-22-2023 04:55 AM

fcitx5 does not more compile with fmt 10.0.0 (the latter upgraded on May 10th).

Already fixed in git (but not yet released):
https://github.com/fcitx/fcitx5/comm...a17b9b8f6a506b

Code:

--- fcitx5-5.0.23/src/modules/dbus/dbusmodule.cpp.orig        2022-11-16 08:56:34.000000000 +0100
+++ fcitx5-5.0.23/src/modules/dbus/dbusmodule.cpp    2023-05-22 11:43:13.224258951 +0200
@@ -571,7 +571,7 @@ public:
                }
                ss << "] program:" << ic->program()
                    << " frontend:" << ic->frontend()
-                  << " cap:" << fmt::format("{:x}", ic->capabilityFlags())
+                  << " cap:" << fmt::format("{:x}", static_cast<uint64_t>(ic->capabilityFlags()))
                    << " focus:" << ic->hasFocus() << std::endl;
                return true;
            });


nobodino 08-28-2023 06:17 AM

Regression test up to "Sat Aug 26 21:01:45 UTC 2023" (x86_64 version).

Not tested for a long time.
Some problems already solved:
- openssh: solved
- fcitx5-m17n: solved
- MPlayer: a solution by marav, but doesn't solve the root cause which is gettext. Buildable
- vulkan: no solution even with newer solution up to 1.3.260.0

Code:

/tmp/VulkanTools-sdk-1.3.204/vkconfig_core/../vkconfig_core/version.h:61:5: note: ‘uint32_t’ is defined in header ‘<cstdint>’; did you forget to ‘#include <cstdint>’?
/tmp/VulkanTools-sdk-1.3.204/vkconfig_core/../vkconfig_core/version.h: In constructor ‘Version::Version()’:
/tmp/VulkanTools-sdk-1.3.204/vkconfig_core/../vkconfig_core/version.h:39:26: error: class ‘Version’ does not have any field named ‘_major’
  39 |    explicit Version() : _major(0), _minor(0), _patch(0) {}
      |                          ^~~~~~
/tmp/VulkanTools-sdk-1.3.204/vkconfig_core/../vkconfig_core/version.h:39:37: error: class ‘Version’ does not have any field named ‘_minor’
  39 |    explicit Version() : _major(0), _minor(0), _patch(0) {}
      |                                    ^~~~~~
/tmp/VulkanTools-sdk-1.3.204/vkconfig_core/../vkconfig_core/version.h:39:48: error: class ‘Version’ does not have any field named ‘_patch’
  39 |    explicit Version() : _major(0), _minor(0), _patch(0) {}
      |                                                ^~~~~~
make[2]: *** [vkconfig_core/CMakeFiles/vkconfig_core.dir/build.make:76: vkconfig_core/CMakeFiles/vkconfig_core.dir/alert.cpp.o] Error 1
make[1]: *** [CMakeFiles/Makefile2:1195: vkconfig_core/CMakeFiles/vkconfig_core.dir/all] Error 2


lucabon 08-29-2023 03:24 AM

Quote:

Originally Posted by nobodino (Post 6450636)
Regression test up to "Sat Aug 26 21:01:45 UTC 2023" (x86_64 version).

- vulkan: no solution even with newer solution up to 1.3.260.0

Version 1.3.250 solves the issue (missing <cstdint> include):
Code:

--- a/vkconfig_core/version.h
+++ b/vkconfig_core/version.h
@@ -22,6 +22,7 @@
 #pragma once
 
 #include <cstddef>
+#include <cstdint>
 #include <string>
 
 #define SUPPORT_LAYER_CONFIG_2_2_0 1


marav 08-29-2023 03:42 AM

For me, both mplayer et vulkan FTBFS have been solved now

nobodino 09-03-2023 12:44 PM

Regression test up to "Fri Sep 1 20:16:14 UTC 2023" (x86_64 version).

Nearly perfect, always the python2-module-collection package but I can trick it.


All times are GMT -5. The time now is 03:07 AM.